#include "filter.h"
#include "math.h"
//#include <stdio.h>


void filter_bio79_plain (float *source, float *dest, int size)
{
  float la = 0.037828, lb = -0.023849, lc = -0.110624, ld = 0.377402, le = 0.852699;
  float ha = -0.064539, hb = 0.040689, hc = 0.418092, hd = -0.788486;

  float *sp  = source;
  float *dpl = dest;
  float *dph = & dest[size/2];

  int i;

  for (i = size / 2; i > 0; i --)
  {
    *dpl = sp[-4]*la + sp[-3]*lb + sp[-2]*lc + sp[-1]*ld + sp[0]*le + sp[1]*ld + sp[2]*lc + sp[3]*lb + sp[4]*la;
    dpl ++;
    *dph = sp[-2]*ha + sp[-1]*hb + sp[0]*hc + sp[1]*hd + sp[2]*hc + sp[3]*hb + sp[4]*ha;
    dph ++;
    sp += 2;
  }
}

void filter_bio79_vec (float *source, float *dest, int size)
{
  filter_bio79_plain (source, dest, size);
}

void rfilter_bio79_plain (float *source, float *dest, int size)
{
  float la = -0.064539, lb = -0.040689, lc = 0.418092, ld = 0.788486;
  float ha = -0.037828, hb = -0.023849, hc = 0.110624, hd = 0.377402, he = -0.852699;

  float *spl = source + 2;
  float *sph = & source[size/2] + 2;
  float *dp  = dest + 4;

  int i;

  for (i = size/2 - 4; i > 0; i --)
  {
    *dp =   spl[-1] * lb + spl[0] * ld + spl[1] * lb
          + sph[-2] * hb + sph[-1] * hd + sph[0] * hd + sph[1] * hb;
    dp ++;
    *dp =   spl[-1] * la + spl[0] * lc + spl[1] * lc + spl[2] * la
          + sph[-2] * ha + sph[-1] * hc + sph[0] * he + sph[1] * hc + sph[2] * ha;
    dp ++;
    spl ++;
    sph ++;
  }
}

void rfilter_bio79_vec (float *source, float *dest, int size)
{
  rfilter_bio79_plain (source, dest, size);
}
