#include "filter.h"
#include "math.h"
//#include <stdio.h>


void filter_daub8_plain (float *source, float *dest, int size)
{
  float la = 0.230378, lb = 0.714847, lc = 0.630881, ld = -0.0279838, le = -0.187035, lf = 0.0308414, lg = 0.032883, lh = -0.0105974;
  float ha = -0.0105974, hb = -0.032883, hc = 0.0308414, hd = 0.187035, he = -0.0279838, hf = -0.630881, hg = 0.714847, hh = -0.230378;

  float *sp  = source;
  float *dpl = dest;
  float *dph = & dest[size/2];

  int i;

  for (i = size / 2; i > 0; i --)
  {
    *dpl =   sp[0]*la + sp[1]*lb + sp[2]*lc + sp[3]*ld
           + sp[4]*le + sp[5]*lf + sp[6]*lg + sp[7]*lh;
    dpl ++;
    *dph =   sp[0]*ha + sp[1]*hb + sp[2]*hc + sp[3]*hd
           + sp[4]*he + sp[5]*hf + sp[6]*hg + sp[7]*hh;
    dph ++;
    sp += 2;
  }
}

void filter_daub8_vec (float *source, float *dest, int size)
{
  filter_daub8_plain (source, dest, size);
}

void rfilter_daub8_plain (float *source, float *dest, int size)
{
  float la = 0.230378, lb = 0.714847, lc = 0.630881, ld = -0.0279838, le = -0.187035, lf = 0.0308414, lg = 0.032883, lh = -0.0105974;
  float ha = -0.0105974, hb = -0.032883, hc = 0.0308414, hd = 0.187035, he = -0.0279838, hf = -0.630881, hg = 0.714847, hh = -0.230378;

  float *spl = source + 2;
  float *sph = & source[size/2] + 2;
  float *dp  = dest + 4;

  int i;

  for (i = size/2 - 4; i > 0; i --)
  {
    *dp =   spl[-3] * lg + spl[-2] * le + spl[-1] * lc + spl[0] * la
          + sph[-3] * hg + sph[-2] * he + sph[-1] * hc + sph[0] * ha;
    dp ++;
    *dp =   spl[-3] * lh + spl[-2] * lf + spl[-1] * ld + spl[0] * lb
          + sph[-3] * hh + sph[-2] * hf + sph[-1] * hd + sph[0] * hb;
    dp ++;
    spl ++;
    sph ++;
  }
}

void rfilter_daub8_vec (float *source, float *dest, int size)
{
  rfilter_daub8_plain (source, dest, size);
}
